// This template is for creating a Strategy that accesses MPaceHist

/*
// Delta Types for MPace
DeltaTypeEnum.BidAsk
DeltaTypeEnum.UpDownTick
DeltaTypeEnum.Psuedo
*/

namespace NinjaTrader.NinjaScript.Strategies
{
	public class MApiMPaceHistStrategy : Strategy
	{
		Indicators.MBoxWaveXE.MPaceHist myPace;

		protected override void OnStateChange()
		{
			// Initialize mpace using Pace Basis Volume (DeltaType is ignored)
			initMPaceHist(ref myPace, "Volume", DeltaTypeEnum.Psuedo);
			
			// Initialize mpace using Pace Basis DeltaVolume using Psuedo delta
			// initMPaceHist(ref myPace, "DeltaVolume", DeltaTypeEnum.Psuedo);

			if (State == State.SetDefaults)
				Calculate = Calculate.OnEachTick;
		}

		protected override void OnBarUpdate()
		{
			// Only process main data series
			if (BarsInProgress != 0) return;

			// Sync with our indicator instance
			myPace.Update();

			Print("MApiMPaceHistStrategy: " + myPace.getPace(0));
		}
	}
}
