// MBoxWave 3.0 Exports Common
namespace NinjaTrader.NinjaScript.Strategies 
{
	partial class Strategy 
	{
		public void setStrategyDelta(DeltaTypeEnum denum) { if ((int) denum <= 1) { if (BarsArray.Length == 1) AddDataSeries(Data.BarsPeriodType.Tick,1);}}
		
		public void initMBidAskOscillator(ref Indicators.MBoxWaveXE.MBidAskOscillator osc, int period, DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && osc == null)
				osc = MBidAskOscillator(period, deltaType);
		}
		
		public void initMCumulativeDelta(ref Indicators.MBoxWaveXE.MCumulativeDelta cum, int period, DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && cum == null)
				cum = MCumulativeDelta(period, deltaType);
		}

		public void initMBoxHistogram(ref Indicators.MBoxWaveXE.MBoxHistogram hist, Display dis, DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && hist == null)
				hist = MBoxHistogram(dis, deltaType, true);
		}
		
		public void initMPaceHist(ref Indicators.MBoxWaveXE.MPaceHist pace, string pb, DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && pace == null)
				pace = MPaceHist(pb, deltaType);
		}

		public void initMGannSwing(ref Indicators.MBoxWaveXE.MGannSwing mg, 
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && mg == null)
				mg = MGannSwing(myReversalAmount, myAlgoSelected, myAlgoFilter, deltaType);
		}

		public void initMWaveChart(ref Indicators.MBoxWaveXE.MWaveChart mw, 
			SwingBase mySwingBase,
			CalculationMode1 myCalcMode,
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && mw == null)
				mw = MWaveChart(mySwingBase, myCalcMode, myReversalAmount, myAlgoSelected, myAlgoFilter, deltaType);
		}
		
		public void initXKontrol(ref Indicators.MBoxWaveXE.XKontrol kontrol)
		{
			if (State == State.Historical && kontrol == null)
				kontrol = XKontrol();
		}
		
		public void initXPace(ref Indicators.MBoxWaveXE.XPace pace)
		{
			if (State == State.Historical && pace == null)
				pace = XPace();
		}
	}
}







namespace NinjaTrader.NinjaScript.Indicators 
{
	partial class Indicator 
	{
		public void setStrategyDelta(DeltaTypeEnum denum) { if ((int) denum <= 1) { if (BarsArray.Length == 1) AddDataSeries(Data.BarsPeriodType.Tick,1);}}
		
		public void initMBidAskOscillator(ref Indicators.MBoxWaveXE.MBidAskOscillator osc, int period, DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && osc == null)
				osc = MBidAskOscillator(period, deltaType);
		}
		
		public void initMCumulativeDelta(ref Indicators.MBoxWaveXE.MCumulativeDelta cum, int period, DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && cum == null)
				cum = MCumulativeDelta(period, deltaType);
		}

		public void initMBoxHistogram(ref Indicators.MBoxWaveXE.MBoxHistogram hist, Display dis, DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && hist == null)
				hist = MBoxHistogram(dis, deltaType, false);
		}
		
		public void initMPaceHist(ref Indicators.MBoxWaveXE.MPaceHist pace, string pb, DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && pace == null)
				pace = MPaceHist(pb, deltaType);
		}

		public void initMGannSwing(ref Indicators.MBoxWaveXE.MGannSwing mg, 
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && mg == null)
				mg = MGannSwing(myReversalAmount, myAlgoSelected, myAlgoFilter, deltaType);
		}

		public void initMWaveChart(ref Indicators.MBoxWaveXE.MWaveChart mw, 
			SwingBase mySwingBase,
			CalculationMode1 myCalcMode,
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			DeltaTypeEnum deltaType)
		{
			if (State == State.Configure) setStrategyDelta(deltaType);

			else if (State == State.Historical && mw == null)
				mw = MWaveChart(mySwingBase, myCalcMode, myReversalAmount, myAlgoSelected, myAlgoFilter, deltaType);
		}
		
		public void initXKontrol(ref Indicators.MBoxWaveXE.XKontrol kontrol)
		{
			if (State == State.Historical && kontrol == null)
				kontrol = XKontrol();
		}
		
		public void initXPace(ref Indicators.MBoxWaveXE.XPace pace)
		{
			if (State == State.Historical && pace == null)
				pace = XPace();
		}
	}
}








namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{

		public MBoxWaveXE.MCumulativeDelta MCumulativeDelta(int myperiod)
		{
			return MCumulativeDelta(myperiod, true);
		}

		public MBoxWaveXE.MCumulativeDelta MCumulativeDelta(int myperiod, bool IS_STRATEGY)
		{
			MBoxWaveXE.MCumulativeDelta[] cacheIndicatorArray = null;
			MBoxWaveXE.MCumulativeDelta cumdelta = new MBoxWaveXE.MCumulativeDelta();
			
			cumdelta.period = myperiod;
			cumdelta.isStrategy = IS_STRATEGY;
			
			return CacheIndicator<MBoxWaveXE.MCumulativeDelta>(cumdelta, Input, ref cacheIndicatorArray);
		}
		
		public MBoxWaveXE.MCumulativeDelta MCumulativeDelta(int myperiod, DeltaTypeEnum denum)
		{
			MBoxWaveXE.MCumulativeDelta[] cacheIndicatorArray = null;
			MBoxWaveXE.MCumulativeDelta cumdelta = new MBoxWaveXE.MCumulativeDelta();
			
			cumdelta.period = myperiod;
			cumdelta.deltaTypeEnum = denum;
			
			return CacheIndicator<MBoxWaveXE.MCumulativeDelta>(cumdelta, Input, ref cacheIndicatorArray);
		}
	}
}


namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{	
		public Indicators.MBoxWaveXE.MCumulativeDelta MCumulativeDelta(int myperiod)
		{
			return indicator.MCumulativeDelta(myperiod, true);
		}
		
		public Indicators.MBoxWaveXE.MCumulativeDelta MCumulativeDelta(int myperiod, DeltaTypeEnum denum)
		{
			return indicator.MCumulativeDelta(myperiod, denum);
		}
	}
}

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{

		public MBoxWaveXE.MGannSwing MGannSwing
		(
			//SwingBase mySwingBase,
			//CalculationMode1 myCalcMode,
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter
		)
		{
			return MGannSwing(//mySwingBase, myCalcMode,
				myReversalAmount, myAlgoSelected, myAlgoFilter, true);
		}

		public MBoxWaveXE.MGannSwing MGannSwing
		(
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			bool IS_STRATEGY
		)
		{
			MBoxWaveXE.MGannSwing[] cacheIndicatorArray = null;
			MBoxWaveXE.MGannSwing mgannswing = new MBoxWaveXE.MGannSwing();

			mgannswing.visual = false;
			mgannswing.isStrategy = IS_STRATEGY;
			
			mgannswing.display = Display.DeltaVolume; // To always calculate delta
			mgannswing.reversal = myReversalAmount.ToString();		
			mgannswing.algoSelected = myAlgoSelected;
			mgannswing.algoFilter = myAlgoFilter;

			return CacheIndicator<MBoxWaveXE.MGannSwing>(mgannswing, Input, ref cacheIndicatorArray);
		}
		
		public MBoxWaveXE.MGannSwing MGannSwing
		(
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			DeltaTypeEnum denum
		)
		{
			MBoxWaveXE.MGannSwing[] cacheIndicatorArray = null;
			MBoxWaveXE.MGannSwing mgannswing = new MBoxWaveXE.MGannSwing();

			mgannswing.visual = false;
			mgannswing.deltaTypeEnum = denum;
			mgannswing.isStrategy = true;
			
			mgannswing.display = Display.DeltaVolume; // To always calculate delta
			mgannswing.reversal = myReversalAmount.ToString();		
			mgannswing.algoSelected = myAlgoSelected;
			mgannswing.algoFilter = myAlgoFilter;

			return CacheIndicator<MBoxWaveXE.MGannSwing>(mgannswing, Input, ref cacheIndicatorArray);
		}
	}
}




namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{	
		public Indicators.MBoxWaveXE.MGannSwing MGannSwing
		(
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter
		)
		{
			return indicator.MGannSwing(myReversalAmount, myAlgoSelected, myAlgoFilter, true);
		}
		
		public Indicators.MBoxWaveXE.MGannSwing MGannSwing
		(
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			DeltaTypeEnum denum
		)
		{
			return indicator.MGannSwing(myReversalAmount, myAlgoSelected, myAlgoFilter, denum);
		}
	}
}

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{

		public MBoxWaveXE.MPaceHist MPaceHist(string pb)
		{
			return MPaceHist(pb, true);
		}

		public MBoxWaveXE.MPaceHist MPaceHist(string pb, bool IS_STRATEGY)
		{
			MBoxWaveXE.MPaceHist[] cacheIndicatorArray = null;
			MBoxWaveXE.MPaceHist mpacehist = new MBoxWaveXE.MPaceHist();
			
			if (pb == "DeltaVolume") 
				mpacehist.paceBasis = PaceBasis.DeltaVolume;

			mpacehist.isStrategy = IS_STRATEGY;
			
			return CacheIndicator<MBoxWaveXE.MPaceHist>(mpacehist, Input, ref cacheIndicatorArray);
		}
		
		public MBoxWaveXE.MPaceHist MPaceHist(string pb, DeltaTypeEnum denum)
		{
			MBoxWaveXE.MPaceHist[] cacheIndicatorArray = null;
			MBoxWaveXE.MPaceHist mpacehist = new MBoxWaveXE.MPaceHist();
			
			if (pb == "DeltaVolume") 
			{
				mpacehist.paceBasis = PaceBasis.DeltaVolume;
				mpacehist.deltaTypeEnum = denum;
			}		
			
			return CacheIndicator<MBoxWaveXE.MPaceHist>(mpacehist, Input, ref cacheIndicatorArray);
		}
	}
}


namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{	
		public Indicators.MBoxWaveXE.MPaceHist MPaceHist(string pb, DeltaTypeEnum denum)
		{
			return indicator.MPaceHist(pb, denum);
		}
	}
}

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{

		public MBoxWaveXE.MWaveChart MWaveChart
		(
			SwingBase mySwingBase,
			CalculationMode1 myCalcMode,
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter
		)
		{
			return MWaveChart(mySwingBase, myCalcMode, myReversalAmount, myAlgoSelected, myAlgoFilter, true);
		}

		public MBoxWaveXE.MWaveChart MWaveChart
		(
			SwingBase mySwingBase,
			CalculationMode1 myCalcMode,
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			bool IS_STRATEGY
		)
		{
			MBoxWaveXE.MWaveChart[] cacheIndicatorArray = null;
			MBoxWaveXE.MWaveChart mwavechart = new MBoxWaveXE.MWaveChart();

			mwavechart.visual = false;
			mwavechart.isStrategy = IS_STRATEGY;
			
			mwavechart.swingBase = mySwingBase;
			mwavechart.display = Display.DeltaVolume; // To always calculate delta
			mwavechart.calcMode = myCalcMode;
			mwavechart.setDeviationType(myCalcMode);
			mwavechart.reversal = myReversalAmount.ToString();		
			mwavechart.algoSelected = myAlgoSelected;
			mwavechart.algoFilter = myAlgoFilter;

			return CacheIndicator<MBoxWaveXE.MWaveChart>(mwavechart, Input, ref cacheIndicatorArray);
		}
		
		public MBoxWaveXE.MWaveChart MWaveChart
		(
			SwingBase mySwingBase,
			CalculationMode1 myCalcMode,
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			DeltaTypeEnum denum
		)
		{
			MBoxWaveXE.MWaveChart[] cacheIndicatorArray = null;
			MBoxWaveXE.MWaveChart mwavechart = new MBoxWaveXE.MWaveChart();

			mwavechart.visual = false;
			mwavechart.isStrategy = true;
			mwavechart.deltaTypeEnum = denum;
			
			mwavechart.swingBase = mySwingBase;
			mwavechart.display = Display.DeltaVolume; // To always calculate delta
			mwavechart.calcMode = myCalcMode;
			mwavechart.setDeviationType(myCalcMode);
			mwavechart.reversal = myReversalAmount.ToString();		
			mwavechart.algoSelected = myAlgoSelected;
			mwavechart.algoFilter = myAlgoFilter;

			return CacheIndicator<MBoxWaveXE.MWaveChart>(mwavechart, Input, ref cacheIndicatorArray);
		}
	}
}




namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{	
		public Indicators.MBoxWaveXE.MWaveChart MWaveChart
		(
			SwingBase mySwingBase,
			CalculationMode1 myCalcMode,
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter
		)
		{
			return indicator.MWaveChart(mySwingBase, myCalcMode, myReversalAmount, myAlgoSelected, myAlgoFilter, true);
		}
		
		public Indicators.MBoxWaveXE.MWaveChart MWaveChart
		(
			SwingBase mySwingBase,
			CalculationMode1 myCalcMode,
			int myReversalAmount,
			AlgoSelected myAlgoSelected,
			AlgoFilter myAlgoFilter,
			DeltaTypeEnum denum
		)
		{
			return indicator.MWaveChart(mySwingBase, myCalcMode, myReversalAmount, myAlgoSelected, myAlgoFilter, denum);
		}
	}
}

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{

		public MBoxWaveXE.MBidAskOscillator MBidAskOscillator(int myperiod)
		{
			return MBidAskOscillator(myperiod, true);
		}

		public MBoxWaveXE.MBidAskOscillator MBidAskOscillator(int myperiod, bool IS_STRATEGY)
		{
			MBoxWaveXE.MBidAskOscillator[] cacheIndicatorArray = null;
			MBoxWaveXE.MBidAskOscillator bidaskoscillator = new MBoxWaveXE.MBidAskOscillator();
			
			bidaskoscillator.period = myperiod;
			bidaskoscillator.isStrategy = IS_STRATEGY;
			
			return CacheIndicator<MBoxWaveXE.MBidAskOscillator>(bidaskoscillator, Input, ref cacheIndicatorArray);
		}
		
		public MBoxWaveXE.MBidAskOscillator MBidAskOscillator(int myperiod, DeltaTypeEnum denum)
		{
			MBoxWaveXE.MBidAskOscillator[] cacheIndicatorArray = null;
			MBoxWaveXE.MBidAskOscillator bidaskoscillator = new MBoxWaveXE.MBidAskOscillator();
			
			bidaskoscillator.period = myperiod;
			bidaskoscillator.deltaTypeEnum = denum;
			
			return CacheIndicator<MBoxWaveXE.MBidAskOscillator>(bidaskoscillator, Input, ref cacheIndicatorArray);
		}
	}
}


namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{	
		public Indicators.MBoxWaveXE.MBidAskOscillator MBidAskOscillator(int myperiod)
		{
			return indicator.MBidAskOscillator(myperiod, true);
		}
		
		public Indicators.MBoxWaveXE.MBidAskOscillator MBidAskOscillator(int myperiod, DeltaTypeEnum denum)
		{
			return indicator.MBidAskOscillator(myperiod, denum);
		}
	}
}




namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		public MBoxWaveXE.MBoxHistogram MBoxHistogram(Display dis, DeltaTypeEnum denum, bool IS_STRATEGY)
		{
			MBoxWaveXE.MBoxHistogram[] cacheIndicatorArray = null;
			MBoxWaveXE.MBoxHistogram hist = new MBoxWaveXE.MBoxHistogram();
			
			hist.display = dis;
			hist.deltaTypeEnum = denum;
			hist.isStrategy = IS_STRATEGY;
			
			return CacheIndicator<MBoxWaveXE.MBoxHistogram>(hist, Input, ref cacheIndicatorArray);
		}


		public MBoxWaveXE.MBoxHistogram MBoxHistogram(Display dis, DeltaTypeEnum denum)
		{
			MBoxWaveXE.MBoxHistogram[] cacheIndicatorArray = null;
			MBoxWaveXE.MBoxHistogram hist = new MBoxWaveXE.MBoxHistogram();
			
			hist.display = dis;
			hist.deltaTypeEnum = denum;
			
			return CacheIndicator<MBoxWaveXE.MBoxHistogram>(hist, Input, ref cacheIndicatorArray);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{			
		public Indicators.MBoxWaveXE.MBoxHistogram MBoxHistogram(Display dis, DeltaTypeEnum denum, bool IS_STRATEGY)
		{
			return indicator.MBoxHistogram(dis, denum, IS_STRATEGY);
		}
	}
}